<?php
/*
 Theme Name: 	DotS
 Theme URI: 	http://dots.nostudio.it/demo
 Description: 	Free and Responsive photography template
 Version: 	1.2
 Author: 	NoStudio - Marco Muià - Giorgio Caristia - Simone Muià
 Author URI: 	http://www.nostudio.it
 Tags: 		minimal,white,wide,photography,potfolio
*/

include( 'admin/cuztom/cuztom.php' );
require_once( 'admin/ns-custom/metaboxes.php' );
require_once( 'admin/ns-custom/upload-logo.php' );
include("admin/ns-custom/update_notifier.php");

####################################################################
function my_wp_is_mobile() {
    if (
        ! empty($_SERVER['HTTP_USER_AGENT'])

        // bail out, if iPad
        && false !== strpos($_SERVER['HTTP_USER_AGENT'], 'iPad')
    ) return false;
    return wp_is_mobile();
} // function my_wp_is_mobile

####################################################################

function dots_scripts() {
	$colors = 'dots_text_color='.get_option('dots_text_color', '333333');
	$colors .= '&dots_link_color='.get_option('dots_link_color', 'ffde0a');
	$colors .= '&dots_link2_color='.get_option('dots_link2_color', 'f0d109');
	$colors .= '&dots_title_color='.get_option('dots_title_color', 'ffde0a');
	$colors .= '&dots_bg_site_color='.get_option('dots_bg_site_color', 'ffffff');
	$colors .= '&dots_bg_menu_color='.get_option('dots_bg_menu_color', 'e6e6e6');
	$colors .= '&dots_bg_menu2_color='.get_option('dots_bg_menu2_color', 'bababa');

	$font = 'font='.get_option('dots_font_family', 'Lato');

	wp_enqueue_script( 'webfont', 'http://ajax.googleapis.com/ajax/libs/webfont/1/webfont.js', array(), '1.0.0', true );
	wp_enqueue_script( 'jquery.nsfont', get_template_directory_uri() .'/scripts/jquery.nsfont.js.php?'.$font, array(), '1.0.0', true );
	wp_enqueue_script( 'jquery.nslogo', get_template_directory_uri() .'/scripts/jquery.nslogo.js.php', array(), '1.0.0', true );
	wp_enqueue_style( 'style', get_template_directory_uri() .'/style.css' );
	wp_enqueue_style( 'nsstyles', get_template_directory_uri() .'/css/nsstyles.php?'.$colors.'&'.$font );
	wp_enqueue_style( 'jquery-ui', get_template_directory_uri() .'/css/jquery-ui.css' );
	wp_enqueue_script( 'jquery', get_template_directory_uri() . '/wp-includes/js/jquery/jquery.js', array(), '1.0.0', true );
	wp_enqueue_script( 'responsiveslides.min', get_template_directory_uri() . '/scripts/responsiveslides.min.js', array(), '1.0.0', true );	
	wp_enqueue_script( 'jquery.nssocial', get_template_directory_uri() . '/scripts/jquery.nssocial.js', array(), '1.0.0', true );
	wp_enqueue_script( 'jquery.nsdots', get_template_directory_uri() . '/scripts/jquery.nsdots.js', array(), '1.0.0', true );
	if (my_wp_is_mobile()) {
		wp_enqueue_script( 'jquery.nsmenu-mobile', get_template_directory_uri() . '/scripts/jquery.nsmenu-mobile.js', array(), '1.0.0', true );
	} else {
		wp_enqueue_script( 'jquery.nsmenu', get_template_directory_uri() . '/scripts/jquery.nsmenu.js', array(), '1.0.0', true );
	}
	wp_enqueue_script( 'jquery-ui', get_template_directory_uri() . '/scripts/jquery-ui.js', array(), '1.0.0', true );
	if (!is_front_page()) {
		wp_enqueue_script( 'jquery.sliderarrow', get_template_directory_uri() . '/scripts/jquery.sliderarrow.js', array(), '1.0.0', true );
	}
}

add_action( 'wp_enqueue_scripts', 'dots_scripts' );

####################################################################

// Add RSS feed links to <head> for posts and comments.
	add_theme_support( 'automatic-feed-links' );

####################################################################

// Custom call for dashboard message
	include("admin/ns-custom/administration-dash.php");

####################################################################

add_filter( 'wp_title', 'baw_hack_wp_title_for_home' );
function baw_hack_wp_title_for_home( $title )
{
  if( empty( $title ) && ( is_home() || is_front_page() ) ) {
    return __(get_bloginfo('description').' | ', 'theme_domain');
  }
  return $title;
}

if ( ! function_exists( 'dots_setup' ) ) :
function dots_setup() {
	add_theme_support( 'post-thumbnails' );
}
endif; // DotS_setup
add_action( 'after_setup_theme', 'dots_setup' );

####################################################################

if ( function_exists('register_sidebar') ){
    register_sidebar(array(
        'name' => 'mainsidebar',
        'before_widget' => '',
        'after_widget' => '',
        'before_title' => '<h4>',
        'after_title' => '</h4>',
    ));
}
// This theme uses wp_nav_menu() in two locations.
register_nav_menus( array(
	'home'   => __( 'Home menu', 'dots' ),
	'inside' => __( 'Inside menu', 'dots' ),
) );
####################################################################
#####################    SHORTCODE    ##############################
####################################################################
remove_filter( 'the_content', 'wpautop' );
remove_filter( 'the_excerpt', 'wpautop' );

function wpse_wpautop_nobr( $content ) {
function tab_shortcode( $atts, $content = null ) {
	return '<div id="tabs">' . do_shortcode($content) . '</div>';
}
add_shortcode( 'tab', 'tab_shortcode' );

function tabs_shortcode( $atts, $content = null ) {
	return '<ul>' . do_shortcode($content) . '</ul>';
}
add_shortcode( 'tabs', 'tabs_shortcode' );

function tabname_shortcode( $atts, $content = null ) {
	$a = shortcode_atts(
		array(
			'id' => '',
		), $atts );
	return '<li><a href="#tabs-'.esc_attr($a['id']).'">' . do_shortcode($content) . '</a></li>';
}
add_shortcode( 'tabname', 'tabname_shortcode' );

function tabtext_shortcode( $atts, $content = null ) {
	$a = shortcode_atts(
		array(
			'id' => '',
		), $atts );
	return '<div id="tabs-'.esc_attr($a['id']).'">' . $content . '</div>';
}
add_shortcode( 'tabtext', 'tabtext_shortcode' );

#####################    COLUMN    ##############################
function column_shortcode( $atts, $content = null ) {
	return '<div class="mainbox">' . do_shortcode($content) . '</div>';
}
add_shortcode( 'column', 'column_shortcode' );

function col50_shortcode( $atts, $content = null ) {
	return '<div class="colbox50">' . do_shortcode($content) . '</div>';
}
add_shortcode( 'col50', 'col50_shortcode' );

function col30_shortcode( $atts, $content = null ) {
	return '<div class="colbox30">' . do_shortcode($content) . '</div>';
}
add_shortcode( 'col30', 'col30_shortcode' );

function col25_shortcode( $atts, $content = null ) {
	return '<div class="colbox25">' . do_shortcode($content) . '</div>';
}
add_shortcode( 'col25', 'col25_shortcode' );

function col20_shortcode( $atts, $content = null ) {
	return '<div class="colbox20">' . do_shortcode($content) . '</div>';
}
add_shortcode( 'col20', 'col20_shortcode' );

return wpautop( $content, false );
}

add_filter( 'the_content', 'wpse_wpautop_nobr' );
add_filter( 'the_excerpt', 'wpse_wpautop_nobr' );

####################################################################
function add_menu() {
	add_menu_page("Amministrazione", "Theme Options", 'administrator',  'theme-option', 'themeoption', '' ,61 );
	add_submenu_page( "theme-option", "Social", "Social", 'administrator', "theme-header", "themeheader" );
	add_submenu_page( "theme-option", "Color", "Color", 'administrator', "theme-color", "themecolor" );
}
add_action('admin_menu', 'add_menu');

/* ************************** Register variables for the Admin Homepage ******************************* */
function register_dots_home_settings() {
	//register our settings
	register_setting( 'option-home-group', 'upload_image' );
	register_setting( 'option-home-group', 'upload_image_retina' );
	register_setting( 'option-home-group', 'dots_font_family' );
	register_setting( 'option-home-group', 'dots_display_home_box' );
}
add_action( 'admin_init', 'register_dots_home_settings' );

/* ************************** Register variables for the Admin Color ******************************* */
function register_dots_color_settings() {
	//register our settings
	register_setting( 'option-color-group', 'dots_text_color' );
	register_setting( 'option-color-group', 'dots_link_color' );
	register_setting( 'option-color-group', 'dots_link2_color' );
	register_setting( 'option-color-group', 'dots_title_color' );
	register_setting( 'option-color-group', 'dots_bg_site_color' );
	register_setting( 'option-color-group', 'dots_bg_menu_color' );
	register_setting( 'option-color-group', 'dots_bg_menu2_color' );
}
add_action( 'admin_init', 'register_dots_color_settings' );

/* ************************** Register variables for the Admin Social ******************************* */
function register_dots_settings() {
	//register our settings
	register_setting( 'myoption-group', 'dots_social_type' );

	register_setting( 'myoption-group', 'dots_email' );
	register_setting( 'myoption-group', 'dots_delicious' );
	register_setting( 'myoption-group', 'dots_facebook' );
	register_setting( 'myoption-group', 'dots_feedrss' );
	register_setting( 'myoption-group', 'dots_flickr' );
	register_setting( 'myoption-group', 'dots_googleplus' );
	register_setting( 'myoption-group', 'dots_instagram' );
	register_setting( 'myoption-group', 'dots_linkedin' );
	register_setting( 'myoption-group', 'dots_picasa' );
	register_setting( 'myoption-group', 'dots_pinterest' );
	register_setting( 'myoption-group', 'dots_share' );
	register_setting( 'myoption-group', 'dots_tumblr' );
	register_setting( 'myoption-group', 'dots_twitter' );
	register_setting( 'myoption-group', 'dots_vimeo' );
	register_setting( 'myoption-group', 'dots_youtube' );
}
add_action( 'admin_init', 'register_dots_settings' );
####################################################################

function themeoption() {
	include("admin/ns-custom/administration.php");
}
####################################################################

function themeheader() {
	include("admin/ns-custom/administration-social.php");
}
####################################################################

function themecolor() {
	include("admin/ns-custom/administration-color.php");
}
####################################################################
######################     RETINA    ###############################
####################################################################
add_action( 'init', 'CJG_retina' );

function CJG_retina(){

    global $is_retina;  
    $is_retina = isset( $_COOKIE["device_pixel_ratio"] ) AND $_COOKIE["device_pixel_ratio"] >= 2;
}

/* ************************** POST TYPE Portfolio ******************************* */

$portfolio = register_cuztom_post_type('portfolio' ,
										array(
											'labels' => array(
												'name' => __( 'Portfolio' ),
												'singular_name' => __( 'Portfolio' )
											),
											'public' => true,
											'has_archive' => true,
											'menu_icon'     => 'dashicons-camera',
											'rewrite' => array('slug' => 'portfolio'),
											'supports' => array( 'title', 'editor', 'thumbnail' ),
									     )
									   );

/* ************************** POST TYPE Page ******************************* */
$pages = new Cuztom_Post_Type('page');

/* ************************** META BOX Portfolio ******************************* */
$portfolio->add_meta_box(
    'meta_box_id',
    'Image',
    array(
            array(
     	    	'name'          => 'name_image1',
   	    	'label'         => 'Image',
    	    	'description'   => 'Image Description',
  	    	'type'          => 'image'
  	  ),
            array(
     	    	'name'          => 'name_image2',
   	    	'label'         => 'Image',
    	    	'description'   => 'Image Description',
  	    	'type'          => 'image'
  	  ),
            array(
     	    	'name'          => 'name_image3',
   	    	'label'         => 'Image',
    	    	'description'   => 'Image Description',
  	    	'type'          => 'image'
  	  ),
            array(
     	    	'name'          => 'name_image4',
   	    	'label'         => 'Image',
    	    	'description'   => 'Image Description',
  	    	'type'          => 'image'
  	  ),
            array(
     	    	'name'          => 'name_image5',
   	    	'label'         => 'Image',
    	    	'description'   => 'Image Description',
  	    	'type'          => 'image'
  	  )
    )
);

/* ************************** META BOX Pages ******************************* */
$pages->add_meta_box(
    'page_meta_box_id',
    'Image',
    array(
            array(
     	    	'name'          => 'name_image1',
   	    	'label'         => 'Image',
    	    	'description'   => 'Image Description',
  	    	'type'          => 'image'
  	  ),
            array(
     	    	'name'          => 'name_image2',
   	    	'label'         => 'Image',
    	    	'description'   => 'Image Description',
  	    	'type'          => 'image'
  	  ),
            array(
     	    	'name'          => 'name_image3',
   	    	'label'         => 'Image',
    	    	'description'   => 'Image Description',
  	    	'type'          => 'image'
  	  )
    )
);

/* ************************** META BOX Staff 1 ******************************* */
$pages->add_meta_box(
    'meta_box_staff_1',	
	'Staff 1',
	array(
			array(
		
				'name'          => 'cpt_staff_img_1',
				'label'         => 'Image',
				'description'   => 'Insert your image here',
				'type'          => 'image'
				),
					
			array(
		
				'name'          => 'cpt_staff_fb_1',
				'label'         => 'Facebook',
				'description'   => 'Insert your page here',
				'type'          => 'text'
				),
		
			array(
		
				'name'          => 'cpt_staff_g_1',
				'label'         => 'Google +',
				'description'   => 'Insert your page here',
				'type'          => 'text'
				),

			array(
		
				'name'          => 'cpt_staff_tw_1',
				'label'         => 'Twitter',
				'description'   => 'Insert your page here',
				'type'          => 'text'
				),

			array(
		
				'name'          => 'cpt_staff_li_1',
				'label'         => 'Linkedin',
				'description'   => 'Insert your page here',
				'type'          => 'text'
				),
				
			array(
		
				'name'          => 'cpt_staff_name_1',
				'label'         => 'Name & Surname',
				'description'   => 'Insert your Name & Surname here',
				'type'          => 'text'
				),	
					
			array(
		
				'name'          => 'cpt_staff_decr_1',
				'label'         => 'Description',
				'description'   => 'Insert your description here',
				'type'          => 'textarea'
				),			

		
	)		
);

/* ************************** META BOX Staff 2 ******************************* */
$pages->add_meta_box(
    'meta_box_staff_2',	
	'Staff 2',
	array(
			array(
		
				'name'          => 'cpt_staff_img_2',
				'label'         => 'Image',
				'description'   => 'Insert your image here',
				'type'          => 'image'
				),
					
			array(
		
				'name'          => 'cpt_staff_fb_2',
				'label'         => 'Facebook',
				'description'   => 'Insert your page here',
				'type'          => 'text'
				),
		
			array(
		
				'name'          => 'cpt_staff_g_2',
				'label'         => 'Google +',
				'description'   => 'Insert your page here',
				'type'          => 'text'
				),

			array(
		
				'name'          => 'cpt_staff_tw_2',
				'label'         => 'Twitter',
				'description'   => 'Insert your page here',
				'type'          => 'text'
				),

			array(
		
				'name'          => 'cpt_staff_li_2',
				'label'         => 'Linkedin',
				'description'   => 'Insert your page here',
				'type'          => 'text'
				),
				
			array(
		
				'name'          => 'cpt_staff_name_2',
				'label'         => 'Name & Surname',
				'description'   => 'Insert your Name & Surname here',
				'type'          => 'text'
				),	
					
			array(
		
				'name'          => 'cpt_staff_decr_2',
				'label'         => 'Description',
				'description'   => 'Insert your description here',
				'type'          => 'textarea'
				),			

		
	)		
);
/* ************************** META BOX Staff 3 ******************************* */
$pages->add_meta_box(
    'meta_box_staff_3',	
	'Staff 3',
	array(
			array(
		
				'name'          => 'cpt_staff_img_3',
				'label'         => 'Image',
				'description'   => 'Insert your image here',
				'type'          => 'image'
				),
					
			array(
		
				'name'          => 'cpt_staff_fb_3',
				'label'         => 'Facebook',
				'description'   => 'Insert your page here',
				'type'          => 'text'
				),
		
			array(
		
				'name'          => 'cpt_staff_g_3',
				'label'         => 'Google +',
				'description'   => 'Insert your page here',
				'type'          => 'text'
				),

			array(
		
				'name'          => 'cpt_staff_tw_3',
				'label'         => 'Twitter',
				'description'   => 'Insert your page here',
				'type'          => 'text'
				),

			array(
		
				'name'          => 'cpt_staff_li_3',
				'label'         => 'Linkedin',
				'description'   => 'Insert your page here',
				'type'          => 'text'
				),
				
			array(
		
				'name'          => 'cpt_staff_name_3',
				'label'         => 'Name & Surname',
				'description'   => 'Insert your Name & Surname here',
				'type'          => 'text'
				),	
					
			array(
		
				'name'          => 'cpt_staff_decr_3',
				'label'         => 'Description',
				'description'   => 'Insert your description here',
				'type'          => 'textarea'
				),			

		
	)		
);

/* ************************** META BOX About ******************************* */
$pages->add_meta_box(
    'meta_box_about',	
	'Social',
	array(
					
			array(
		
				'name'          => 'cpt_about_fb',
				'label'         => 'Facebook',
				'description'   => 'Insert your page here',
				'type'          => 'text'
				),
		
			array(
		
				'name'          => 'cpt_about_g',
				'label'         => 'Google +',
				'description'   => 'Insert your page here',
				'type'          => 'text'
				),

			array(
		
				'name'          => 'cpt_about_tw',
				'label'         => 'Twitter',
				'description'   => 'Insert your page here',
				'type'          => 'text'
				),

			array(
		
				'name'          => 'cpt_about_li',
				'label'         => 'Linkedin',
				'description'   => 'Insert your page here',
				'type'          => 'text'
				),
											
	)		
);

####################################################################
add_action( 'widgets_init', 'init_footer_widget' );

function init_footer_widget() {
	register_sidebar( array(
		'name' => __( 'Footer Widget 1', 'DotS' ),
		'id' => 'foter-widget1',
		'description' => __( 'Footer Widget 1', 'DotS' ),
		'before_widget' => '<li id="%1$s">',
		'after_widget' => '</li>',
		'before_title' => '<h3>',
		'after_title' => '</h3>',
	));

	register_sidebar( array(
		'name' => __( 'Footer Widget 2', 'DotS' ),
		'id' => 'foter-widget2',
		'description' => __( 'Footer Widget  2', 'DotS' ),
		'before_widget' => '<li id="%1$s">',
		'after_widget' => '</li>',
		'before_title' => '<h3>',
		'after_title' => '</h3>',
	));

	register_sidebar( array(
		'name' => __( 'Footer Widget 3', 'DotS' ),
		'id' => 'foter-widget3',
		'description' => __( 'Footer Widget 3', 'DotS' ),
		'before_widget' => '<li id="%1$s">',
		'after_widget' => '</li>',
		'before_title' => '<h3>',
		'after_title' => '</h3>',
	));

	register_sidebar( array(
		'name' => __( 'Footer Widget 4', 'DotS' ),
		'id' => 'foter-widget4',
		'description' => __( 'Footer Widget 4', 'DotS' ),
		'before_widget' => '<li id="%1$s">',
		'after_widget' => '</li>',
		'before_title' => '<h3>',
		'after_title' => '</h3>',
	));
}
function ns_footer() {
	echo '<div id="copyright">&copy; Copyright <a href="http://www.nostudio.it/dots-theme">NoStudio</a> 2014</div>';
}
function ns_social() {
	include("admin/ns-custom/ns-social.php");
}
?>