<?php
/*
Template Name: Page Contact
*/
get_header();
?>
<?php
 
  //response generation function
  $response = "";
 
  //function to generate response
  function my_contact_form_generate_response($type, $message){
 
    global $response;
 
    if($type == "success") $response = "<div class='success'>{$message}</div>";
    else $response = "<div class='error'>{$message}</div>";
 
  }
//response messages
$not_human       = "Human verification incorrect.";
$missing_content = "Please supply all information.";
$email_invalid   = "Email Address Invalid.";
$message_unsent  = "Message was not sent. Try Again.";
$message_sent    = "Thanks! Your message has been sent.";
 
//user posted variables
$name = $_POST['message_name'];
$email = $_POST['message_email'];
$message = $_POST['message_text'];
$human = $_POST['message_human'];
 
//php mailer variables
$to = get_option('admin_email');
$subject = "Someone sent a message from ".get_bloginfo('name');
$headers = 'From: '.$email.' <'. $email .'>' ."\r\n" .'Reply-To: ' . $email . "\r\n";
// Human verification
if(!$human == 0){
  if($human != 2) my_contact_form_generate_response("error", $not_human); //not human!
  else {
 
//validate email
if(!filter_var($email, FILTER_VALIDATE_EMAIL))
  my_contact_form_generate_response("error", $email_invalid);
else //email is valid
{
//validate presence of name and message
if(empty($name) || empty($message)){
  my_contact_form_generate_response("error", $missing_content);
}
else //ready to go!
{
$sent = wp_mail($to, $subject, strip_tags($message), $headers);
if($sent) my_contact_form_generate_response("success", $message_sent);
else my_contact_form_generate_response("error", $message_unsent);
}
}

  }
}
else if ($_POST['submitted']) my_contact_form_generate_response("error", $missing_content);

?>

<?php get_header(); ?>
  <div id="mainBar">
    <!-- item -->
    <?php if (have_posts()) : while (have_posts()) : the_post(); ?>
    <div class="item entry" id="post-<?php the_ID(); ?>">

      <div class="storycontent">
	<div class="pagecontact">
        <?php the_content(); ?>
        <?php wp_link_pages(array('before' => '<p><strong>Pages:</strong> ', 'after' => '</p>', 'next_or_number' => 'number')); ?>
	<p>
 
<div id="respond">
  <?php echo $response; ?>
  <form name="contactformsend" action="<?php the_permalink(); ?>" method="post">
    <p><label for="name">Name: <span>*</span> <br><input type="text" name="message_name" value="<?php echo esc_attr($_POST['message_name']); ?>" class="nscontacttext" /></label></p>
    <p><label for="message_email">Email: <span>*</span> <br><input type="text" name="message_email" value="<?php echo esc_attr($_POST['message_email']); ?>" class="nscontacttext" /></label></p>
    <p><label for="message_text">Message: <span>*</span> <br><textarea type="text" name="message_text" class="nscontactarea"><?php echo esc_textarea($_POST['message_text']); ?></textarea></label></p>
    <p><label for="message_human">Human Verification: <span>*</span> <br><input type="text" class="nscontacthuman" name="message_human"> + 3 = 5</label></p>
    <input type="hidden" name="submitted" value="1"><br />
    <p><a href="#" onclick="document.contactformsend.submit(); return false;" class="nscontactsend">invia</a></p>
  </form>
</div>
	</p>
      </div>
    </div>
    </div>
    <?php edit_post_link('Edit this entry.', '<p>', '</p>'); ?>
    <!-- end item -->
    <?php endwhile; ?>
    <?php endif; ?>
   </div>
     <?php get_sidebar(); ?>
<?php get_footer(); ?>